//
// HotelSearchListViewController.h
// Project
//
// Created by Ziv on 15/12/11.
//
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "WebService.h"
#import "RoomBasedCountViewController.h"

@interface HotelSearchListParam : NSObject

@property (nonatomic, strong) NSString *destination;
@property (nonatomic, strong) NSString *checkIn;
@property (nonatomic, strong) NSString *checkOut;
@property (nonatomic, strong) NSArray *roomInfo;
@property (nonatomic, strong) NSString *keywords;

@property (nonatomic, strong) NSString *minPrice;
@property (nonatomic, strong) NSString *maxPrice;
@property (nonatomic, strong) NSMutableArray *stars;
@property (nonatomic, strong) NSMutableArray *brands;
@property (nonatomic, strong) NSMutableArray *locations;
@property (nonatomic, strong) NSMutableArray *boards;
@property (nonatomic, strong) NSMutableArray *amenities;
@property (nonatomic, strong) NSString *orderBy;
@property (nonatomic, assign) BOOL isBusHotelPackage;

@property (nonatomic, assign, readonly) NSInteger roomCount;
@property (nonatomic, assign, readonly) NSInteger nights;

- (NSDictionary *)toParameters;

@end

@interface HotelSearchPaginationParam : HotelSearchListParam

@property (nonatomic, assign) NSInteger pageNumber;

- (NSDictionary *)toParameters;

@end

@interface HotelSearchListViewController : UITableViewController

@property (nonatomic, strong) HotelSearchPaginationParam *hotelSearchParam;
@property (nonatomic, assign) BOOL isBusHotelPackage;
@property (nonatomic, assign) BOOL canEdit;

- (void)clearHotelSearchResults;

@end
